## unittest++ 1.2.1

=== Makefile ===
CC = g++
CCFLAGS = -g -ansi -Wall -W -ansi # -pedantic
SED = sed
MV = mv
RM = rm

.SUFFIXES: .o .cpp

lib = libUnitTest++.a
test = TestUnitTest++

src = src/AssertException.cpp \
	src/Test.cpp \
	src/Checks.cpp \
	src/TestRunner.cpp \
	src/TestResults.cpp \
	src/TestReporter.cpp \
	src/TestReporterStdout.cpp \
	src/ReportAssert.cpp \
	src/TestList.cpp \
	src/TimeConstraint.cpp \
	src/TestDetails.cpp \
	src/MemoryOutStream.cpp \
	src/DeferredTestReporter.cpp \
	src/DeferredTestResult.cpp \
	src/XmlTestReporter.cpp \
	src/Posix/SignalTranslator.cpp \
	src/Posix/TimeHelpers.cpp

test_src = src/tests/Main.cpp \
	src/tests/TestAssertHandler.cpp \
	src/tests/TestChecks.cpp \
	src/tests/TestUnitTest++.cpp \
	src/tests/TestTest.cpp \
	src/tests/TestTestResults.cpp \
	src/tests/TestTestRunner.cpp \
	src/tests/TestCheckMacros.cpp \
	src/tests/TestTestList.cpp \
	src/tests/TestTestMacros.cpp \
	src/tests/TestTimeConstraint.cpp \
	src/tests/TestTimeConstraintMacro.cpp \
	src/tests/TestMemoryOutStream.cpp \
	src/tests/TestDeferredTestReporter.cpp \
	src/tests/TestXmlTestReporter.cpp

objects = $(patsubst %.cpp, %.o, $(src))
test_objects = $(patsubst %.cpp, %.o, $(test_src))
dependencies = $(subst .o,.d,$(objects))
test_dependencies = $(subst .o,.d,$(test_objects))

define make-depend
  $(CC) $(CCFLAGS) -M $1 | \
  $(SED) -e 's,\($(notdir $2)\) *:,$(dir $2)\1: ,' > $3.tmp
  $(SED) -e 's/#.*//' \
      -e 's/^[^:]*: *//' \
      -e 's/ *\\$$//' \
      -e '/^$$/ d' \
      -e 's/$$/ :/' $3.tmp >> $3.tmp
  $(MV) $3.tmp $3
endef


all: $(test)


$(lib): $(objects) 
	@echo Creating $(lib) library...
	@ar cr $(lib) $(objects)
    
$(test): $(lib) $(test_objects)
	@echo Linking $(test)...
	@$(CC) -o $(test) $(test_objects) $(lib)
	@echo Running unit tests...
	@./$(test)

clean:
	-@$(RM) $(objects) $(test_objects) $(dependencies) $(test_dependencies) $(test) $(lib) 2> /dev/null

%.o : %.cpp
	@echo $<
	@$(call make-depend,$<,$@,$(subst .o,.d,$@))
	@$(CC) $(CCFLAGS) -c $< -o $(patsubst %.cpp, %.o, $<)


ifneq "$(MAKECMDGOALS)" "clean"
-include $(dependencies)
-include $(test_dependencies)
endif

## unittest++ 1.4.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
-CC = g++
-CCFLAGS = -g -ansi -Wall -W -ansi # -pedantic
+CXX = g++
+CXXFLAGS ?= -g -Wall -W -ansi # -pedantic
+LDFLAGS ?= 
 SED = sed
 MV = mv
 RM = rm
@@ -24,8 +25,14 @@
 	src/DeferredTestReporter.cpp \
 	src/DeferredTestResult.cpp \
 	src/XmlTestReporter.cpp \
-	src/Posix/SignalTranslator.cpp \
+	src/CurrentTest.cpp
+	
+ifeq ($(MSYSTEM), MINGW32)
+  src += src/Win32/TimeHelpers.cpp
+else
+  src += src/Posix/SignalTranslator.cpp \
 	src/Posix/TimeHelpers.cpp
+endif
 
 test_src = src/tests/Main.cpp \
 	src/tests/TestAssertHandler.cpp \
@@ -41,7 +48,8 @@
 	src/tests/TestTimeConstraintMacro.cpp \
 	src/tests/TestMemoryOutStream.cpp \
 	src/tests/TestDeferredTestReporter.cpp \
-	src/tests/TestXmlTestReporter.cpp
+	src/tests/TestXmlTestReporter.cpp \
+	src/tests/TestCurrentTest.cpp
 
 objects = $(patsubst %.cpp, %.o, $(src))
 test_objects = $(patsubst %.cpp, %.o, $(test_src))
@@ -49,7 +57,7 @@
 test_dependencies = $(subst .o,.d,$(test_objects))
 
 define make-depend
-  $(CC) $(CCFLAGS) -M $1 | \
+  $(CXX) $(CXXFLAGS) -M $1 | \
   $(SED) -e 's,\($(notdir $2)\) *:,$(dir $2)\1: ,' > $3.tmp
   $(SED) -e 's/#.*//' \
       -e 's/^[^:]*: *//' \
@@ -69,7 +77,7 @@
     
 $(test): $(lib) $(test_objects)
 	@echo Linking $(test)...
-	@$(CC) -o $(test) $(test_objects) $(lib)
+	@$(CXX) $(LDFLAGS) -o $(test) $(test_objects) $(lib)
 	@echo Running unit tests...
 	@./$(test)
 
@@ -79,7 +87,7 @@
 %.o : %.cpp
 	@echo $<
 	@$(call make-depend,$<,$@,$(subst .o,.d,$@))
-	@$(CC) $(CCFLAGS) -c $< -o $(patsubst %.cpp, %.o, $<)
+	@$(CXX) $(CXXFLAGS) -c $< -o $(patsubst %.cpp, %.o, $<)
 
 
 ifneq "$(MAKECMDGOALS)" "clean"

## unittest++ 1.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.1)
project(UnitTest++)

option(UTPP_USE_PLUS_SIGN "Set this to OFF is you with to use '-cpp' instead of '++' in lib/include paths" ON)

if(MSVC14 OR MSVC12)
    # has the support we need
else()
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    if(COMPILER_SUPPORTS_CXX14)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    elseif(COMPILER_SUPPORTS_CXX11)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    else()
            message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
    endif()
endif()

# get the main sources
file(GLOB headers_ RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} UnitTest++/*.h)
file(GLOB sources_ RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} UnitTest++/*.cpp)
source_group("" FILES ${headers_} ${sources_})

# get platform specific sources
if (WIN32)
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    set(platformDir_ Win32)
else()
    set(platformDir_ Posix)
endif(WIN32)

file(GLOB platformHeaders_ RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} UnitTest++/${platformDir_}/*.h)
file(GLOB platformSources_ RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} UnitTest++/${platformDir_}/*.cpp)
source_group(${platformDir_} FILES ${platformHeaders_} ${platformSources_})

# create the lib
add_library(UnitTest++ STATIC ${headers_} ${sources_} ${platformHeaders_} ${platformSources_})

if(${UTPP_USE_PLUS_SIGN})
	set_target_properties(UnitTest++ PROPERTIES OUTPUT_NAME UnitTest++)
endif()


# build the test runner
file(GLOB TEST_SRCS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tests/*.cpp tests/*.h)
source_group( "" FILES ${TEST_SRCS})
add_executable(TestUnitTest++ ${TEST_SRCS})
include_directories(.)

if(${UTPP_USE_PLUS_SIGN})
	set_target_properties(TestUnitTest++ PROPERTIES OUTPUT_NAME TestUnitTest++)
endif()

target_link_libraries(TestUnitTest++ UnitTest++)

# run unit tests as post build step
add_custom_command(TARGET TestUnitTest++
	POST_BUILD COMMAND TestUnitTest++
	COMMENT "Running unit tests")

# add install targets
# need a custom install path?
# define CMAKE_INSTALL_PREFIX to change root folder
if(${UTPP_USE_PLUS_SIGN})
	set (UTPP_INSTALL_DESTINATION "include/UnitTest++")
else()
	set (UTPP_INSTALL_DESTINATION "include/UnitTestPP")
endif()

install(TARGETS UnitTest++ DESTINATION lib)
install(FILES ${headers_} DESTINATION ${UTPP_INSTALL_DESTINATION})
install(FILES ${platformHeaders_} DESTINATION ${UTPP_INSTALL_DESTINATION}/${platformDir_})

## unittest++ 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,15 @@
 cmake_minimum_required(VERSION 2.8.1)
 project(UnitTest++)
 
-option(UTPP_USE_PLUS_SIGN "Set this to OFF is you with to use '-cpp' instead of '++' in lib/include paths" ON)
+option(UTPP_USE_PLUS_SIGN
+    "Set this to OFF if you wish to use '-cpp' instead of '++' in lib/include paths"
+    ON)
+option(UTPP_INCLUDE_TESTS_IN_BUILD
+    "Set this to OFF if you do not wish to automatically build or run unit tests as part of the default cmake --build"
+    ON)
+option(UTPP_AMPLIFY_WARNINGS
+    "Set this to OFF if you wish to use CMake default warning levels; should generally only use to work around support issues for your specific compiler"
+    ON)
 
 if(MSVC14 OR MSVC12)
     # has the support we need
@@ -15,6 +23,17 @@
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
     else()
             message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
+    endif()
+endif()
+
+# up warning level for project
+if (${UTPP_AMPLIFY_WARNINGS})
+    # instead of getting compiler specific, we're going to try making an assumption that an existing /W# means
+    # we are dealing with an MSVC or MSVC-like compiler (e.g. Intel on Windows)
+    if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
+        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX")
+    else()
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror")
     endif()
 endif()
 
@@ -57,8 +76,12 @@
 
 # run unit tests as post build step
 add_custom_command(TARGET TestUnitTest++
-	POST_BUILD COMMAND TestUnitTest++
-	COMMENT "Running unit tests")
+    POST_BUILD COMMAND TestUnitTest++
+    COMMENT "Running unit tests")
+
+if(NOT ${UTPP_INCLUDE_TESTS_IN_BUILD})
+    set_target_properties(TestUnitTest++ PROPERTIES EXCLUDE_FROM_ALL 1)
+endif()
 
 # add install targets
 # need a custom install path?
@@ -69,6 +92,19 @@
 	set (UTPP_INSTALL_DESTINATION "include/UnitTestPP")
 endif()
 
-install(TARGETS UnitTest++ DESTINATION lib)
+set(config_install_dir_ lib/cmake/${PROJECT_NAME})
+set(targets_export_name_ "${PROJECT_NAME}Targets")
+
+install(TARGETS UnitTest++ EXPORT "${targets_export_name_}" DESTINATION lib)
 install(FILES ${headers_} DESTINATION ${UTPP_INSTALL_DESTINATION})
 install(FILES ${platformHeaders_} DESTINATION ${UTPP_INSTALL_DESTINATION}/${platformDir_})
+install(FILES cmake/UnitTest++Config.cmake DESTINATION "${config_install_dir_}")
+install(EXPORT "${targets_export_name_}" DESTINATION "${config_install_dir_}")
+
+set(prefix      ${CMAKE_INSTALL_PREFIX})
+set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
+set(libdir      ${CMAKE_INSTALL_PREFIX}/lib)
+set(includedir  ${CMAKE_INSTALL_PREFIX}/include/UnitTest++)
+configure_file("UnitTest++.pc.in" "UnitTest++.pc" @ONLY)
+install(FILES       "${CMAKE_CURRENT_BINARY_DIR}/UnitTest++.pc"
+        DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig")

=== debian/changelog ===
unittest++ (2.0.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Jun 2017 11:30:32 +0200

unittest++ (2.0.0-1~exp2) experimental; urgency=medium

  * Fix copyright issues, thanks Chris Lamb!
    (Closes: #860343)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 16 Apr 2017 07:52:30 +0200

unittest++ (2.0.0-1~exp1) experimental; urgency=medium

  [ Jari Aalto ]
  * Convert to format-3.0 (Closes: #664372).
  * Bump std-version to 3.9.8.

  [ Gianfranco Costamagna ]
  * Move to collab-maint
  * Build in clean chroot (Closes: #789463)
  * New upstream snapshot. (Closes: #784665)
  * Adopt the package.
  * Switch to dh
  * Switch to cmake
  * Use compat level 10
  * d/copyright convert to dep5 format.
  * d/watch: fix url location.
  * d/patches/10_pkgconfig.patch: remove, addressed upstream.
  * d/patches/20_test_runner_bad_virtual_method_arg.patch
    remove, addressed upstream.
  * d/patches/version.patch: hardcode upstream version.
  * d/control:
    - convert to multiarch
    - add libunittest++2 package
  * d/libunittest++-dev.docs remove the html reference, dropped
    upstream.
 
 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Apr 2017 10:04:30 +0200

unittest++ (1.4.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC6 by using -std=gnu++98 (Closes: #812270).
  * Add explicit debian/source/format.

 -- Andrey Rahmatullin <wrar@debian.org>  Sat, 03 Dec 2016 20:49:24 +0500

unittest++ (1.4.0-3) unstable; urgency=low

  * Add missing 20_test_runner_bad_virtual_method_arg.dpatch to patches/00list

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Sat, 11 Jul 2009 15:18:30 +0200

unittest++ (1.4.0-2) unstable; urgency=low

  * Fix FTBFS on non-x86 arches (Closes: #525709)

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Tue, 09 Jun 2009 02:24:58 +0200

unittest++ (1.4.0-1) unstable; urgency=low

  * New upstream version
  * Drop 20_gcc-4.3.dpatch, fixed upstream
  * Remove empty libunittest++0 transitional package (Closes: #489122)
  * Bump standards-version to 3.8.1
  * Add get-orig-source target
  * Repackage upstream tarball using get-orig-source target	
  * Add libunittest++-dev.docs
  * Fix debhelper-but-no-misc-depends
  * Fix dev-package-should-be-section-libdevel
  * Fix dpatch-missing-description

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Sat, 25 Apr 2009 01:20:17 +0200

unittest++ (1.3.0-4) unstable; urgency=low

  * Apply Cyril Brulebois patch to fix FTBFS with GCC 4.3 (Closes: #455316)

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Thu, 13 Mar 2008 13:53:11 +0000

unittest++ (1.3.0-3) unstable; urgency=low

  * add watch file
  * fix install rules

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Mon, 29 Oct 2007 01:39:20 +0000

unittest++ (1.3.0-2) unstable; urgency=low

  * fix libunittest++0 override and section missmatch

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Sun, 28 Oct 2007 13:43:42 +0000

unittest++ (1.3.0-1) unstable; urgency=low

  * 1.3 release (upstream sync)
  * remove autotools support, use upstream provided makefile instead
  * empty libunittest++0  transition package
  * rename library to libUnitTest++.a, provide simlink for backward compatibility
  * switch to dpatch
  * new 10_pkgconfig.dpatch with updated version and paths

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Wed, 26 Sep 2007 12:18:24 +0000

unittest++ (1.2.1-1) unstable; urgency=low

  * upstream patch for autotools and packaging fixes

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Wed,  6 Dec 2006 04:08:15 +0100

unittest++ (1.2.0-5) unstable; urgency=low

  * update debhelper version (closes: #397810)

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Thu, 30 Nov 2006 22:48:00 +0100

unittest++ (1.2.0-4) unstable; urgency=low

  * bump closes

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Thu, 30 Nov 2006 15:13:51 +0100

unittest++ (1.2.0-3) unstable; urgency=low

  * packaging fix

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Wed, 22 Nov 2006 18:03:28 +0100

unittest++ (1.2.0-2) unstable; urgency=low

  * copyright fixes

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Wed, 22 Nov 2006 15:42:53 +0100

unittest++ (1.2.0-1) unstable; urgency=low

  * 1.2 release (upstream sync)

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Mon, 30 Oct 2006 17:13:00 +0200
	

unittest++ (1.1.1-1) unstable; urgency=low

  * g++ depends
  
  * upstream sync

 -- Loic Dachary (OuoU) <loic@debian.org>  Mon, 30 Oct 2006 11:31:52 +0100

unittest++ (1.1.0-1) unstable; urgency=low

  * 1.1 release

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Wed, 12 May 2006 16:08:00 +0200

unittest++ (1.0.0-1) unstable; urgency=low

  * initial package

 -- Johan Euphrosine (proppy) <proppy@aminche.com>  Wed, 29 Mar 2006 15:58:02 +0200

=== debian/control ===
Source: unittest++
Section: devel
Priority: optional
Homepage: https://github.com/unittest-cpp/unittest-cpp
Maintainer: Johan Euphrosine (proppy) <proppy@aminche.com>
Uploaders: Loic Dachary (OuoU) <loic@debian.org>,
           Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 10)
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/unittest++.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/unittest++.git

Package: libunittest++-dev
Section: libdevel
Architecture: any
Depends: libunittest++2 (=${binary:Version}), ${misc:Depends}
Description: unit testing framework for c++, static library and headers
 unittest++ is a unit testing framework designed for simplicity
 and portability. Features include no explicit test registration,
 good crash handling, fixtures, rich condition-checking functionality,
 minimal footprint for embedded environments.

Package: libunittest++2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: unit testing framework for c++, runtime library
 unittest++ is a unit testing framework designed for simplicity
 and portability. Features include no explicit test registration,
 good crash handling, fixtures, rich condition-checking functionality,
 minimal footprint for embedded environments.
 .
 Provides the Unittest library

=== debian/watch ===
version=3
https://github.com/unittest-cpp/unittest-cpp/releases .*/v(\d\S*)\.tar\.gz
